/* ipuz-barred.c
 *
 * Copyright 2023 Jonathan Blandford <jrb@gnome.org>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */


#include "libipuz-config.h"
#include <libipuz/ipuz-barred.h>


static void                ipuz_barred_init         (IPuzBarred      *self);
static void                ipuz_barred_class_init   (IPuzBarredClass *klass);
static const gchar *const *ipuz_barred_get_kind_str (IPuzPuzzle      *puzzle);



G_DEFINE_TYPE (IPuzBarred, ipuz_barred, IPUZ_TYPE_CROSSWORD);


static void
ipuz_barred_init (IPuzBarred *self)
{
  /* Pass */
}

static void
ipuz_barred_class_init (IPuzBarredClass *klass)
{
  IPuzPuzzleClass *puzzle_class = IPUZ_PUZZLE_CLASS (klass);

  puzzle_class->get_kind_str = ipuz_barred_get_kind_str;
}

static const gchar *const *
ipuz_barred_get_kind_str (IPuzPuzzle *puzzle)
{
  static const char *kind_str[] =
    {
      "http://ipuz.org/crossword#1",
      "http://libipuz.org/barred#1",
      NULL
    };

  return kind_str;
}


/**
 * Public Methods
 */

IPuzPuzzle *
ipuz_barred_new (void)
{
  IPuzPuzzle *barred;

  barred = g_object_new (IPUZ_TYPE_BARRED,
                         "puzzle-kind", IPUZ_PUZZLE_BARRED,
                         NULL);

  return barred;
}
